# LifePex

## Dependencies

* git
* ruby 3
* sqlite or postgresql

## Setup

```
# Install dependencies
bundle install

# SQLITE
./init/database.rb sqlite://sqlite.db

# POSTGRESQL
psql -U postgres postgres -c "CREATE USER root WITH PASSWORD 'toor' SUPERUSER;"
psql -U postgres postgres -c "CREATE DATABASE life_pex"
./init/database.rb postgres://root:toor@localhost/life_pex
```

## Start

```
export LIFEPEX_SECRET="put something random here"
export LIFEPEX_BASE_URL="https://mydomain/base"
export LIFEPEX_DB="sqlite://sqlite.db"
# you may also want to use postgres or something
# export LIFEPEX_DB="postgres://root:toor@localhost/life_pex"
# export LIFEPEX_BIND="0.0.0.0" # you may want to bind against something else than 127.0.01
# export LIFEPEX_ENV="production" # why not hide stacktraces ?
./src/app.rb
```

## Generate documentation

```
./init/doc.rb
xdg-open ./public/doc/index.html
```

## Features

* [x] Register an account
* [x] Reset password
* [x] Add pex models
* [x] Add point each day to each pex model
* [x] Make a nice smooth level function
* [x] Create a nice CSS template to make it dark and flashy and cyberpunk kikoo
* [x] Protect privacy with private pex models
* [x] Import CSV script
* [x] Make a basic recap graph
* [x] Make a niice recap graph
* [x] Add an easy and quick way to edit pex
* [x] Add advanced pex with variable value
* [ ] Improve security (token validity limit, random seed warning, ...)

![recap image](https://git.sceptique.eu/attachments/ce7c2fab-bd1b-43fc-b10a-21b2c953e2c2)
![today image](https://git.sceptique.eu/attachments/ecd7a36d-eac7-40aa-b973-c6ddbac87f51)
